globals
[
 
]

turtles-own
[
 argumentR                   ; the risk-argument based on the product of importance and valence
 argumentB                   ; the benefit-argument based on the product of importance and valence
 argumentP                   ; the process-argument based on the product of importance and valence
 
 argumentR_imp               ; the importance for risk-argument
 argumentR_val               ; the valence for risk-argument
 
 argumentB_imp               ; the importance for benefit-argument
 argumentB_val               ; the valence for benefit-argument
 
 argumentP_imp               ; the importance for process-argument
 argumentP_val               ; the valence for process-argument
 
 position_AR                 ; position of risk-argument on the latitudes (rej,acc or ncomm) 
 position_AB                 ; position of benefit-argument on the latitudes (rej,acc or ncomm)
 position_AP                 ; position of process-argument on the latitudes (rej,acc or ncomm)
 
 s                           ; coefficient to slow down the adaptation of the argument (to be computed as s*y)

]


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


to setup
  
  clear-all 
  reset-ticks
 

  ask patches 
  [set pcolor black
    sprout 1 
    ]
  
  ask turtles 
  [ 
    create-links-to turtles-on neighbors             
    set shape "person"
    
    import-val&imp_argb                ; import the values of importance and valence for the benefit-argument
    import-position_Ab                   ; imports the position for benefit-argument on the latitudes (rejection, acceptance, non-commitment)
    
    import-val&imp_argr                ; import the values of importance and valence for the risk-argument
    import-position_Ar                   ; imports the position for risik-argument on the latitudes (rejection, acceptance, non-commitment)
    
    import-val&imp_argp                ; import the values of importance and valence for the process-argument
    import-position_Ap                   ; imports the position for process-argument on the latitudes (rejection, acceptance, non-commitment)
    
    
    foreach sort turtles [
    set argumentb (argumentb_imp * argumentb_val)      ;compute the value of the benefit argument depending on the importance and valence
    ]
    
    if argumentb > 1
      [set argumentb 1]
    if argumentb < -1
      [set argumentb -1]
      
    
    foreach sort turtles [
    set argumentr (argumentr_imp * argumentr_val)      ;compute the value of the risk argument depending on the importance and valence
    ]
    
    if argumentr > 1
      [set argumentr 1]
    if argumentr < -1
      [set argumentr -1]
      
    foreach sort turtles [
    set argumentp (argumentp_imp * argumentp_val)      ;compute the value of the process argument depending on the importance and valence
    ]
    
    if argumentp > 1
      [set argumentp 1]
    if argumentp < -1
      [set argumentp -1]
      
   
  ]
end


to show-data 
  ask turtles
  [
    set s 1 / 100 
  ]
  
  update_argument_values-plot 
end


to import-val&imp_argB                ; import the values of importance and valence for the benefit-argument
  file-open "C:\\yourpath.txt" 
   foreach sort turtles
     [ask ?
       [set argumentb_imp file-read
        set argumentb_val file-read
       ]
      ]
    file-close
end

 
to import-position_Ab                   ; imports the position for benefit-argument on the latitudes (rejection, acceptance, non-commitment)
    file-open "C:\\yourpath.txt" 
   foreach sort turtles
     [ask ?
       [set position_Ab file-read
       ]
      ]
    file-close   
end


to import-val&imp_argR                ; import the values of importance and valence for the risk-argument
  file-open "C:\\yourpath.txt" 
   foreach sort turtles
     [ask ?
       [set argumentr_imp file-read
        set argumentr_val file-read
       ]
      ]
    file-close
end
 
to import-position_Ar                   ; imports the position for risk-argument on the latitudes (rejection, acceptance, non-commitment)
    file-open "C:\\yourpath.txt" 
   foreach sort turtles
     [ask ?
       [set position_Ar file-read
       ]
      ]
    file-close   
end 

    to import-val&imp_argP                ; import the values of importance and valence for the process-argument
  file-open "C:\\yourpath.txt" 
   foreach sort turtles
     [ask ?
       [set argumentp_imp file-read
        set argumentp_val file-read
       ]
      ]
    file-close
end
 
to import-position_Ap                   ; imports the position for process-argument on the latitudes (rejection, acceptance, non-commitment)
    file-open "C:\\yourpath.txt" 
   foreach sort turtles
     [ask ?
       [set position_Ap file-read
       ]
      ]
    file-close   
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; INTERACTION!!!  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to start
 
  tick
     interaction 
      
     if Pause = true
      [if ticks >= Stop-value [stop]]
      
      
      update_argument_values-plot      
end 


to interaction
  
  ask patches
    [set pcolor black 
        ]
  
  ask turtles
    [ let neighbor_ArgR 0    ; local variable risk-argument of the neighbor
      let neighbor_ArgB 0    ; local variable benefit-argument of the neighbor
      let neighbor_ArgP 0    ; local variable process-argument of the neighbor
   
      if any? in-link-neighbors                            
       [ 
          foreach sort in-link-neighbors                        
          [
            set neighbor_ArgR [argumentR] of  one-of in-link-neighbors          
            set neighbor_ArgB [argumentB] of  one-of in-link-neighbors
            set neighbor_ArgP [argumentP] of  one-of in-link-neighbors
          ]
          
      
;;;;;;;;;;;;;;;;;;;;;;;;; RISK-ARGUMENT COMPARISON ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      
      if position_AR = 2                                    ;; the risk-argument in the latitude of non-commitment
        [
          set argumentR argumentR
         ]
        
        
      if position_AR = 1 and argumentR > 0 and neighbor_ArgR > 0    ;; the risk-argument in the latitude of rejection
        [
          set argumentR argumentR - neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 1 and argumentR > 0 and neighbor_ArgR < 0    ;; the risk-argument in the latitude of rejection
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 1 and argumentR < 0 and neighbor_ArgR < 0    ;; the risk-argument in the latitude of rejection
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 1 and argumentR < 0 and neighbor_ArgR > 0    ;; the risk-argument in the latitude of rejection
        [
          set argumentR argumentR - neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 1 and argumentR = 0 or argumentR < 0 or argumentR > 0 and neighbor_ArgR = 0    ;; the risk-argument in the latitude of rejection
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
         ]  
      if position_AR = 1 and argumentR = 0 and neighbor_ArgR > 0    ;; the risk-argument in the latitude of rejection
        [
          set argumentR argumentR - neighbor_ArgR ^ 2 * s
        ]  
      if position_AR = 1 and argumentR < 0 and neighbor_ArgR < 0    ;; the risk-argument in the latitude of rejection
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
        ]
      
        
        if position_AR = 3 and argumentR > 0 and neighbor_ArgR > 0    ;; the risk-argument in the latitude of acceptance
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 3 and argumentR > 0 and neighbor_ArgR < 0    ;; the risk-argument in the latitude of acceptance
        [
          set argumentR argumentR - neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 3 and argumentR < 0 and neighbor_ArgR < 0    ;; the risk-argument in the latitude of acceptance
        [
          set argumentR argumentR - neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 3 and argumentR < 0 and neighbor_ArgR > 0    ;; the risk-argument in the latitude of acceptance
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
         ]
      if position_AR = 3 and argumentR = 0 or argumentR < 0 or argumentR > 0 and neighbor_ArgR = 0    ;; the risk-argument in the latitude of acceptance
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
         ]  
      if position_AR = 3 and argumentR = 0 and neighbor_ArgR > 0    ;; the risk-argument in the latitude of acceptance
        [
          set argumentR argumentR + neighbor_ArgR ^ 2 * s
        ]  
      if position_AR = 3 and argumentR < 0 and neighbor_ArgR < 0    ;; the risk-argument in the latitude of acceptance
        [
          set argumentR argumentR - neighbor_ArgR ^ 2 * s
        ]
        
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; BENEFIT-ARGUMENT COMPARISON ;;;;;;;;;


      
      if position_AB = 2                                    ;; the benefit-argument in the latitude of non-commitment
        [
          set argumentB argumentB
         ]
        
        
      if position_AB = 1 and argumentB > 0 and neighbor_ArgB > 0    ;; the benefit-argument in the latitude of rejection
        [
          set argumentB argumentB - neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 1 and argumentB > 0 and neighbor_ArgB < 0    ;; the benefit-argument in the latitude of rejection
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 1 and argumentB < 0 and neighbor_ArgB < 0    ;; the benefit-argument in the latitude of rejection
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 1 and argumentB < 0 and neighbor_ArgB > 0    ;; the benefit-argument in the latitude of rejection
        [
          set argumentB argumentB - neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 1 and argumentB = 0 or argumentB < 0 or argumentB > 0 and neighbor_ArgB = 0    ;; the benefit-argument in the latitude of rejection
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
         ]  
      if position_AB = 1 and argumentB = 0 and neighbor_ArgB > 0    ;; the benefit-argument in the latitude of rejection
        [
          set argumentB argumentB - neighbor_ArgB ^ 2 * s
        ]  
      if position_AB = 1 and argumentB < 0 and neighbor_ArgB < 0    ;; the benefit-argument in the latitude of rejection
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
        ]  
        
        
        
        if position_AB = 3 and argumentB > 0 and neighbor_ArgB > 0    ;; the benefit-argument in the latitude of acceptance
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 3 and argumentB > 0 and neighbor_ArgB < 0    ;; the benefit-argument in the latitude of acceptance
        [
          set argumentB argumentB - neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 3 and argumentB < 0 and neighbor_ArgB < 0    ;; the benefit-argument in the latitude of acceptance
        [
          set argumentB argumentB - neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 3 and argumentB < 0 and neighbor_ArgB > 0    ;; the benefit-argument in the latitude of acceptance
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
         ]
      if position_AB = 3 and argumentB = 0 or argumentB < 0 or argumentB > 0 and neighbor_ArgB = 0    ;; the benefit-argument in the latitude of acceptance
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
         ]  
      if position_AB = 3 and argumentB = 0 and neighbor_ArgB > 0    ;; the benefit-argument in the latitude of acceptance
        [
          set argumentB argumentB + neighbor_ArgB ^ 2 * s
        ]  
      if position_AB = 3 and argumentB < 0 and neighbor_ArgB < 0    ;; the benefit-argument in the latitude of acceptance
        [
          set argumentB argumentB - neighbor_ArgB ^ 2 * s
        ]  
        

   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; PROCESS-ARGUMENT COMPARISON ;;;;;;;;;


      
      if position_AP = 2                                    ;; the process-argument in the latitude of non-commitment
        [
          set argumentP argumentP
         ]
        
        
      if position_AP = 1 and argumentP > 0 and neighbor_ArgP > 0    ;; the process-argument in the latitude of rejection
        [
          set argumentP argumentP - neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 1 and argumentP > 0 and neighbor_ArgP < 0    ;; the process-argument in the latitude of rejection
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 1 and argumentP < 0 and neighbor_ArgP < 0    ;; the process-argument in the latitude of rejection
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 1 and argumentP < 0 and neighbor_ArgP > 0    ;; the process-argument in the latitude of rejection
        [
          set argumentP argumentP - neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 1 and argumentP = 0 or argumentP < 0 or argumentP > 0 and neighbor_ArgP = 0    ;; the process-argument in the latitude of rejection
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
         ]  
      if position_AP = 1 and argumentP = 0 and neighbor_ArgP > 0    ;; the process-argument in the latitude of rejection
        [
          set argumentP argumentP - neighbor_ArgP ^ 2 * s
        ]  
      if position_AP = 1 and argumentP < 0 and neighbor_ArgP < 0    ;; the process-argument in the latitude of rejection
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
        ]  
      
      
        
        
        if position_AP = 3 and argumentP > 0 and neighbor_ArgP > 0    ;; the process-argument in the latitude of acceptance
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 3 and argumentP > 0 and neighbor_ArgP < 0    ;; the process-argument in the latitude of acceptance
        [
          set argumentP argumentP - neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 3 and argumentP < 0 and neighbor_ArgP < 0    ;; the process-argument in the latitude of acceptance
        [
          set argumentP argumentP - neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 3 and argumentP < 0 and neighbor_ArgP > 0    ;; the process-argument in the latitude of acceptance
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
         ]
      if position_AP = 3 and argumentP = 0 or argumentP < 0 or argumentP > 0 and neighbor_ArgP = 0    ;; the process-argument in the latitude of acceptance
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
         ]  
      if position_AP = 3 and argumentP = 0 and neighbor_ArgP > 0    ;; the process-argument in the latitude of acceptance
        [
          set argumentP argumentP + neighbor_ArgP ^ 2 * s
        ]  
      if position_AP = 3 and argumentP < 0 and neighbor_ArgP < 0    ;; the process-argument in the latitude of acceptance
        [
          set argumentP argumentP - neighbor_ArgP ^ 2 * s
        ]  
      
     foreach sort turtles [
    if argumentR > 1
      [set argumentR 1]
    if argumentR < -1
      [set argumentR -1]
     ]

     foreach sort turtles [
    if argumentB > 1
      [set argumentB 1]
    if argumentB < -1
      [set argumentB -1]
     ]
     
    foreach sort turtles [
    if argumentP > 1
      [set argumentP 1]
    if argumentP < -1
      [set argumentP -1] 
    ]     
       ]
    ]
     
   update_argument_values-plot
   
   update_arguments_output 
end



to update_argument_values-plot
  set-current-plot "Benefit & Risk Values Distribution"
  set-current-plot-pen "benefit-a"
  set-plot-pen-mode 1  
  histogram [ argumentb] of turtles
  set-current-plot-pen "risk-a" 
  set-plot-pen-mode 1  
  histogram [ argumentr] of turtles
  
  set-current-plot "Process Values Distribution"
  set-current-plot-pen "process-a"
  set-plot-pen-mode 1  
  histogram [ argumentp] of turtles  
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Export csv files of the results of the arguments

to update_arguments_output
  
;;;;;; output for every agent, no means
 
 file-open "C:\\yourpath.csv"
 file-type "tick,"
  file-type "id,"
  file-print "argumentr,argumentb,argumentp,position_AR,position_AB,position_AP"
  file-close
  file-open "C:\\yourpath.csv"
  ask turtles
  [
    file-type (word ticks ",")
    file-type (word who ",")
    file-print (word argumentr "," argumentb "," argumentp "," position_AR "," position_AB "," position_AP)
    
  ]
  file-close   

;;;;;;;;;;;;; output over all agents (and for every agent) for the means of risk, benefit, and process
   
   
   let mean_argumentr mean [argumentr] of turtles
   let mean_argumentb mean [argumentb] of turtles
   let mean_argumentp mean [argumentp] of turtles
   
  
  file-open "C:\\yourpath.csv"
  file-type "ticks,"
  file-print "mean_argumentr,mean_argumentb,mean_argumentp"
  file-close
  file-open "C:\\yourpath.csv"
  
  ask turtles
  [
    file-type (word ticks ",")
    file-print (word mean_argumentr "," mean_argumentb "," mean_argumentp)
    
  ]
  
  file-close 
end  
  
@#$#@#$#@
GRAPHICS-WINDOW
21
67
642
709
-1
-1
21.07
1
10
1
1
1
0
1
1
1
0
28
0
28
0
0
1
ticks
30.0

BUTTON
12
10
90
43
Setup
Setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
182
10
245
43
NIL
Start
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
649
68
1402
278
Benefit & Risk Values Distribution
Values
Agents
-1.0
1.0
0.0
30.0
true
true
"" ""
PENS
"Benefit-A" 0.1 1 -14439633 true "" ""
"Risk-A" 0.1 1 -5298144 true "" ""

BUTTON
96
10
176
43
NIL
Show-data
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
649
346
1401
556
Process Values Distribution
Values
Agents
-1.0
1.0
0.0
30.0
true
true
"" ""
PENS
"Process-A" 0.1 1 -13791810 true "" ""

BUTTON
251
10
338
43
Step once
start
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
422
10
517
55
Stop-value
Stop-value
10 50 100 110 120 130 140 150 200 250 300 350 360 370 380 390 400 450 500 550 560 570 580 590 600 700 800 900 1000 1500 2000
18

SWITCH
530
10
644
43
Pause
Pause
0
1
-1000

MONITOR
857
290
946
335
Mean Process
precision mean [argumentp] of turtles 4
17
1
11

MONITOR
762
290
831
335
Mean Risk
precision mean [argumentr] of turtles 4
17
1
11

MONITOR
650
290
736
335
Mean Benefit
precision mean [argumentb] of turtles 4
17
1
11

@#$#@#$#@
## WHAT IS IT?

This ABM simulates opinions on a topic (originally contested infrastructures) through the interactions between paired agents and based on the sociopsychological assumptions of social judgment theory (SJT; Sherif & Hovland, 1961). The model shows the opinion dynamics of individuals and the whole agent population regarding a specific issue over time. The model is based on empirical data (raw data not included in the model).

## HOW IT WORKS

The argument values Ax for every agent i assumes values between [-1, 1] and are computed as the product of valence Vx [-1, 1] and importance Ix [0, 1] for each argument (taken from empirical data). 
				Ax = Vx * Ix
For all three arguments, each agent profile includes the information about the location of the respective arguments on the individual’s opinion structure based on the latitudes described in the SJT (taken from empirical data). One time step t in the simulation represented one interaction between all pairs of agents. The paired agents are randomly chosen from the social network.

The 841 agents are located on a 29 x 29 grid with wrapped boundaries. 
Each agent randomly chooses a neighbor in its social network and starts to interact. The interaction is one-directional. The adaptation depends on where the compared argument is located on the agent’s social judgment continuum (i.e., in which of the three latitudes) and whether the values of the compared arguments Axa and Axb have the same or opposite directions (i.e., positive or negative).
During the interaction, the interacting agent sequentially chooses one of the arguments x and checks which of its latitudes the argument belonged to. 

If the chosen argument is in the latitude of non-commitment, no adaptation occurred. The argument value Axa of the interacting agent stays the same. Then the interacting agent moves on and sequentially selects the next argument. 

If the argument belongs to the latitude of rejection or acceptance, then an adaptation occurs. The quadratic term in the function has been chosen to best represent the two effects of contrast and assimilation described in the SJT. The speed of change in the values of the arguments for each agent is regulated by the constant s set at s = 0.01.

Generally, when adaptation occurs, the values of Ax would be permitted to shift up (down) to a maximum (minimum) of 1 (-1). 


## HOW TO USE IT

Push "setup" for initializing the agents in the model. For this step, an import of empirical data is needed. 
Push "show data" after the setup procedure to show the graphs in the interface. 

Select the "pause" slider for stopping the interaction after a given amount of ticks ("stop-value"-slider).

## THINGS TO NOTICE

As this model is based on collected empirical data, the input data is not made available for this purpose. However, one can easily create a distribution of values (i.e., valence, importance, latitudes) for trying the model and to experiment with it. 

## EXTENDING THE MODEL

More arguments can be added, as well as new interaction processes (i.e., learning, new arguments, etc...)


## CREDITS AND REFERENCES

Stefanelli, A. & Seidl, R., Opinions on contested energy infrastructures: An empirically based simulation approach, Journal of Environmental Psychology (2016), doi:10.1016/j.jenvp.2016.06.003
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment" repetitions="1" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>count turtles</metric>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
